package info.bukova.isspst.filters;

import static info.bukova.isspst.StringUtils.nullStr;
import info.bukova.isspst.data.Workgroup;

import org.hamcrest.Description;
import org.hamcrest.Factory;
import org.hamcrest.Matcher;
import org.hamcrest.TypeSafeMatcher;

public class WorkgroupFilter implements Filter<Workgroup> {
	
	private Workgroup condWorkgroup;
	
	public WorkgroupFilter(Workgroup condWorkgroup) {
		this.condWorkgroup = condWorkgroup;
	}

	private static class WorkgroupMatcher extends TypeSafeMatcher<Workgroup> {

		private Workgroup condWorkgroup;
		
		public WorkgroupMatcher(Workgroup cond) {
			this.condWorkgroup = cond;
		}
		
		@Override
		public void describeTo(Description desc) {
			desc.appendText("material matches");
		}

		@Override
		public boolean matchesSafely(Workgroup item) {
			return nullStr(item.getCode()).toLowerCase().contains(nullStr(condWorkgroup.getCode()).toLowerCase()) 
					&& nullStr(item.getName()).toLowerCase().contains(nullStr(condWorkgroup.getName()).toLowerCase())
					&& item.isCentre() == condWorkgroup.isCentre();
		}
		
		@Factory
		public static Matcher<Workgroup> matchBuilding(Workgroup material) {
			return new WorkgroupMatcher(material);
		}
	}
	
	@Override
	public WorkgroupMatcher matcher() {
		return new WorkgroupMatcher(condWorkgroup);
	}

	@Override
	public String queryString() {
		// TODO query string
		return "";
	}

}
